// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"database/sql/driver"
	"errors"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/google/uuid"
	"github.com/vorteil/direktiv/ent/predicate"
	"github.com/vorteil/direktiv/ent/workflow"
	"github.com/vorteil/direktiv/ent/workflowevents"
	"github.com/vorteil/direktiv/ent/workflowinstance"
)

// WorkflowInstanceQuery is the builder for querying WorkflowInstance entities.
type WorkflowInstanceQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.WorkflowInstance
	// eager-loading edges.
	withWorkflow *WorkflowQuery
	withInstance *WorkflowEventsQuery
	withFKs      bool
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the WorkflowInstanceQuery builder.
func (wiq *WorkflowInstanceQuery) Where(ps ...predicate.WorkflowInstance) *WorkflowInstanceQuery {
	wiq.predicates = append(wiq.predicates, ps...)
	return wiq
}

// Limit adds a limit step to the query.
func (wiq *WorkflowInstanceQuery) Limit(limit int) *WorkflowInstanceQuery {
	wiq.limit = &limit
	return wiq
}

// Offset adds an offset step to the query.
func (wiq *WorkflowInstanceQuery) Offset(offset int) *WorkflowInstanceQuery {
	wiq.offset = &offset
	return wiq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (wiq *WorkflowInstanceQuery) Unique(unique bool) *WorkflowInstanceQuery {
	wiq.unique = &unique
	return wiq
}

// Order adds an order step to the query.
func (wiq *WorkflowInstanceQuery) Order(o ...OrderFunc) *WorkflowInstanceQuery {
	wiq.order = append(wiq.order, o...)
	return wiq
}

// QueryWorkflow chains the current query on the "workflow" edge.
func (wiq *WorkflowInstanceQuery) QueryWorkflow() *WorkflowQuery {
	query := &WorkflowQuery{config: wiq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := wiq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := wiq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(workflowinstance.Table, workflowinstance.FieldID, selector),
			sqlgraph.To(workflow.Table, workflow.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, workflowinstance.WorkflowTable, workflowinstance.WorkflowColumn),
		)
		fromU = sqlgraph.SetNeighbors(wiq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryInstance chains the current query on the "instance" edge.
func (wiq *WorkflowInstanceQuery) QueryInstance() *WorkflowEventsQuery {
	query := &WorkflowEventsQuery{config: wiq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := wiq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := wiq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(workflowinstance.Table, workflowinstance.FieldID, selector),
			sqlgraph.To(workflowevents.Table, workflowevents.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, workflowinstance.InstanceTable, workflowinstance.InstanceColumn),
		)
		fromU = sqlgraph.SetNeighbors(wiq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first WorkflowInstance entity from the query.
// Returns a *NotFoundError when no WorkflowInstance was found.
func (wiq *WorkflowInstanceQuery) First(ctx context.Context) (*WorkflowInstance, error) {
	nodes, err := wiq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{workflowinstance.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (wiq *WorkflowInstanceQuery) FirstX(ctx context.Context) *WorkflowInstance {
	node, err := wiq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first WorkflowInstance ID from the query.
// Returns a *NotFoundError when no WorkflowInstance ID was found.
func (wiq *WorkflowInstanceQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = wiq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{workflowinstance.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (wiq *WorkflowInstanceQuery) FirstIDX(ctx context.Context) int {
	id, err := wiq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single WorkflowInstance entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when exactly one WorkflowInstance entity is not found.
// Returns a *NotFoundError when no WorkflowInstance entities are found.
func (wiq *WorkflowInstanceQuery) Only(ctx context.Context) (*WorkflowInstance, error) {
	nodes, err := wiq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{workflowinstance.Label}
	default:
		return nil, &NotSingularError{workflowinstance.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (wiq *WorkflowInstanceQuery) OnlyX(ctx context.Context) *WorkflowInstance {
	node, err := wiq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only WorkflowInstance ID in the query.
// Returns a *NotSingularError when exactly one WorkflowInstance ID is not found.
// Returns a *NotFoundError when no entities are found.
func (wiq *WorkflowInstanceQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = wiq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{workflowinstance.Label}
	default:
		err = &NotSingularError{workflowinstance.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (wiq *WorkflowInstanceQuery) OnlyIDX(ctx context.Context) int {
	id, err := wiq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of WorkflowInstances.
func (wiq *WorkflowInstanceQuery) All(ctx context.Context) ([]*WorkflowInstance, error) {
	if err := wiq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return wiq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (wiq *WorkflowInstanceQuery) AllX(ctx context.Context) []*WorkflowInstance {
	nodes, err := wiq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of WorkflowInstance IDs.
func (wiq *WorkflowInstanceQuery) IDs(ctx context.Context) ([]int, error) {
	var ids []int
	if err := wiq.Select(workflowinstance.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (wiq *WorkflowInstanceQuery) IDsX(ctx context.Context) []int {
	ids, err := wiq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (wiq *WorkflowInstanceQuery) Count(ctx context.Context) (int, error) {
	if err := wiq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return wiq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (wiq *WorkflowInstanceQuery) CountX(ctx context.Context) int {
	count, err := wiq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (wiq *WorkflowInstanceQuery) Exist(ctx context.Context) (bool, error) {
	if err := wiq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return wiq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (wiq *WorkflowInstanceQuery) ExistX(ctx context.Context) bool {
	exist, err := wiq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the WorkflowInstanceQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (wiq *WorkflowInstanceQuery) Clone() *WorkflowInstanceQuery {
	if wiq == nil {
		return nil
	}
	return &WorkflowInstanceQuery{
		config:       wiq.config,
		limit:        wiq.limit,
		offset:       wiq.offset,
		order:        append([]OrderFunc{}, wiq.order...),
		predicates:   append([]predicate.WorkflowInstance{}, wiq.predicates...),
		withWorkflow: wiq.withWorkflow.Clone(),
		withInstance: wiq.withInstance.Clone(),
		// clone intermediate query.
		sql:  wiq.sql.Clone(),
		path: wiq.path,
	}
}

// WithWorkflow tells the query-builder to eager-load the nodes that are connected to
// the "workflow" edge. The optional arguments are used to configure the query builder of the edge.
func (wiq *WorkflowInstanceQuery) WithWorkflow(opts ...func(*WorkflowQuery)) *WorkflowInstanceQuery {
	query := &WorkflowQuery{config: wiq.config}
	for _, opt := range opts {
		opt(query)
	}
	wiq.withWorkflow = query
	return wiq
}

// WithInstance tells the query-builder to eager-load the nodes that are connected to
// the "instance" edge. The optional arguments are used to configure the query builder of the edge.
func (wiq *WorkflowInstanceQuery) WithInstance(opts ...func(*WorkflowEventsQuery)) *WorkflowInstanceQuery {
	query := &WorkflowEventsQuery{config: wiq.config}
	for _, opt := range opts {
		opt(query)
	}
	wiq.withInstance = query
	return wiq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		InstanceID string `json:"instanceID,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.WorkflowInstance.Query().
//		GroupBy(workflowinstance.FieldInstanceID).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
//
func (wiq *WorkflowInstanceQuery) GroupBy(field string, fields ...string) *WorkflowInstanceGroupBy {
	group := &WorkflowInstanceGroupBy{config: wiq.config}
	group.fields = append([]string{field}, fields...)
	group.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := wiq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return wiq.sqlQuery(ctx), nil
	}
	return group
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		InstanceID string `json:"instanceID,omitempty"`
//	}
//
//	client.WorkflowInstance.Query().
//		Select(workflowinstance.FieldInstanceID).
//		Scan(ctx, &v)
//
func (wiq *WorkflowInstanceQuery) Select(field string, fields ...string) *WorkflowInstanceSelect {
	wiq.fields = append([]string{field}, fields...)
	return &WorkflowInstanceSelect{WorkflowInstanceQuery: wiq}
}

func (wiq *WorkflowInstanceQuery) prepareQuery(ctx context.Context) error {
	for _, f := range wiq.fields {
		if !workflowinstance.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if wiq.path != nil {
		prev, err := wiq.path(ctx)
		if err != nil {
			return err
		}
		wiq.sql = prev
	}
	return nil
}

func (wiq *WorkflowInstanceQuery) sqlAll(ctx context.Context) ([]*WorkflowInstance, error) {
	var (
		nodes       = []*WorkflowInstance{}
		withFKs     = wiq.withFKs
		_spec       = wiq.querySpec()
		loadedTypes = [2]bool{
			wiq.withWorkflow != nil,
			wiq.withInstance != nil,
		}
	)
	if wiq.withWorkflow != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, workflowinstance.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		node := &WorkflowInstance{config: wiq.config}
		nodes = append(nodes, node)
		return node.scanValues(columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		if len(nodes) == 0 {
			return fmt.Errorf("ent: Assign called without calling ScanValues")
		}
		node := nodes[len(nodes)-1]
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	if err := sqlgraph.QueryNodes(ctx, wiq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := wiq.withWorkflow; query != nil {
		ids := make([]uuid.UUID, 0, len(nodes))
		nodeids := make(map[uuid.UUID][]*WorkflowInstance)
		for i := range nodes {
			if nodes[i].workflow_instances == nil {
				continue
			}
			fk := *nodes[i].workflow_instances
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(workflow.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "workflow_instances" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.Workflow = n
			}
		}
	}

	if query := wiq.withInstance; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[int]*WorkflowInstance)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.Instance = []*WorkflowEvents{}
		}
		query.withFKs = true
		query.Where(predicate.WorkflowEvents(func(s *sql.Selector) {
			s.Where(sql.InValues(workflowinstance.InstanceColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.workflow_instance_instance
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "workflow_instance_instance" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "workflow_instance_instance" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Instance = append(node.Edges.Instance, n)
		}
	}

	return nodes, nil
}

func (wiq *WorkflowInstanceQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := wiq.querySpec()
	return sqlgraph.CountNodes(ctx, wiq.driver, _spec)
}

func (wiq *WorkflowInstanceQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := wiq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (wiq *WorkflowInstanceQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   workflowinstance.Table,
			Columns: workflowinstance.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: workflowinstance.FieldID,
			},
		},
		From:   wiq.sql,
		Unique: true,
	}
	if unique := wiq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := wiq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, workflowinstance.FieldID)
		for i := range fields {
			if fields[i] != workflowinstance.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := wiq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := wiq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := wiq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := wiq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (wiq *WorkflowInstanceQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(wiq.driver.Dialect())
	t1 := builder.Table(workflowinstance.Table)
	selector := builder.Select(t1.Columns(workflowinstance.Columns...)...).From(t1)
	if wiq.sql != nil {
		selector = wiq.sql
		selector.Select(selector.Columns(workflowinstance.Columns...)...)
	}
	for _, p := range wiq.predicates {
		p(selector)
	}
	for _, p := range wiq.order {
		p(selector)
	}
	if offset := wiq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := wiq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// WorkflowInstanceGroupBy is the group-by builder for WorkflowInstance entities.
type WorkflowInstanceGroupBy struct {
	config
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (wigb *WorkflowInstanceGroupBy) Aggregate(fns ...AggregateFunc) *WorkflowInstanceGroupBy {
	wigb.fns = append(wigb.fns, fns...)
	return wigb
}

// Scan applies the group-by query and scans the result into the given value.
func (wigb *WorkflowInstanceGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := wigb.path(ctx)
	if err != nil {
		return err
	}
	wigb.sql = query
	return wigb.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (wigb *WorkflowInstanceGroupBy) ScanX(ctx context.Context, v interface{}) {
	if err := wigb.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from group-by.
// It is only allowed when executing a group-by query with one field.
func (wigb *WorkflowInstanceGroupBy) Strings(ctx context.Context) ([]string, error) {
	if len(wigb.fields) > 1 {
		return nil, errors.New("ent: WorkflowInstanceGroupBy.Strings is not achievable when grouping more than 1 field")
	}
	var v []string
	if err := wigb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (wigb *WorkflowInstanceGroupBy) StringsX(ctx context.Context) []string {
	v, err := wigb.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (wigb *WorkflowInstanceGroupBy) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = wigb.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workflowinstance.Label}
	default:
		err = fmt.Errorf("ent: WorkflowInstanceGroupBy.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (wigb *WorkflowInstanceGroupBy) StringX(ctx context.Context) string {
	v, err := wigb.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from group-by.
// It is only allowed when executing a group-by query with one field.
func (wigb *WorkflowInstanceGroupBy) Ints(ctx context.Context) ([]int, error) {
	if len(wigb.fields) > 1 {
		return nil, errors.New("ent: WorkflowInstanceGroupBy.Ints is not achievable when grouping more than 1 field")
	}
	var v []int
	if err := wigb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (wigb *WorkflowInstanceGroupBy) IntsX(ctx context.Context) []int {
	v, err := wigb.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (wigb *WorkflowInstanceGroupBy) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = wigb.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workflowinstance.Label}
	default:
		err = fmt.Errorf("ent: WorkflowInstanceGroupBy.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (wigb *WorkflowInstanceGroupBy) IntX(ctx context.Context) int {
	v, err := wigb.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from group-by.
// It is only allowed when executing a group-by query with one field.
func (wigb *WorkflowInstanceGroupBy) Float64s(ctx context.Context) ([]float64, error) {
	if len(wigb.fields) > 1 {
		return nil, errors.New("ent: WorkflowInstanceGroupBy.Float64s is not achievable when grouping more than 1 field")
	}
	var v []float64
	if err := wigb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (wigb *WorkflowInstanceGroupBy) Float64sX(ctx context.Context) []float64 {
	v, err := wigb.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (wigb *WorkflowInstanceGroupBy) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = wigb.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workflowinstance.Label}
	default:
		err = fmt.Errorf("ent: WorkflowInstanceGroupBy.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (wigb *WorkflowInstanceGroupBy) Float64X(ctx context.Context) float64 {
	v, err := wigb.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from group-by.
// It is only allowed when executing a group-by query with one field.
func (wigb *WorkflowInstanceGroupBy) Bools(ctx context.Context) ([]bool, error) {
	if len(wigb.fields) > 1 {
		return nil, errors.New("ent: WorkflowInstanceGroupBy.Bools is not achievable when grouping more than 1 field")
	}
	var v []bool
	if err := wigb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (wigb *WorkflowInstanceGroupBy) BoolsX(ctx context.Context) []bool {
	v, err := wigb.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (wigb *WorkflowInstanceGroupBy) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = wigb.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workflowinstance.Label}
	default:
		err = fmt.Errorf("ent: WorkflowInstanceGroupBy.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (wigb *WorkflowInstanceGroupBy) BoolX(ctx context.Context) bool {
	v, err := wigb.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (wigb *WorkflowInstanceGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range wigb.fields {
		if !workflowinstance.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := wigb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := wigb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (wigb *WorkflowInstanceGroupBy) sqlQuery() *sql.Selector {
	selector := wigb.sql
	columns := make([]string, 0, len(wigb.fields)+len(wigb.fns))
	columns = append(columns, wigb.fields...)
	for _, fn := range wigb.fns {
		columns = append(columns, fn(selector))
	}
	return selector.Select(columns...).GroupBy(wigb.fields...)
}

// WorkflowInstanceSelect is the builder for selecting fields of WorkflowInstance entities.
type WorkflowInstanceSelect struct {
	*WorkflowInstanceQuery
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (wis *WorkflowInstanceSelect) Scan(ctx context.Context, v interface{}) error {
	if err := wis.prepareQuery(ctx); err != nil {
		return err
	}
	wis.sql = wis.WorkflowInstanceQuery.sqlQuery(ctx)
	return wis.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (wis *WorkflowInstanceSelect) ScanX(ctx context.Context, v interface{}) {
	if err := wis.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from a selector. It is only allowed when selecting one field.
func (wis *WorkflowInstanceSelect) Strings(ctx context.Context) ([]string, error) {
	if len(wis.fields) > 1 {
		return nil, errors.New("ent: WorkflowInstanceSelect.Strings is not achievable when selecting more than 1 field")
	}
	var v []string
	if err := wis.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (wis *WorkflowInstanceSelect) StringsX(ctx context.Context) []string {
	v, err := wis.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a selector. It is only allowed when selecting one field.
func (wis *WorkflowInstanceSelect) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = wis.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workflowinstance.Label}
	default:
		err = fmt.Errorf("ent: WorkflowInstanceSelect.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (wis *WorkflowInstanceSelect) StringX(ctx context.Context) string {
	v, err := wis.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from a selector. It is only allowed when selecting one field.
func (wis *WorkflowInstanceSelect) Ints(ctx context.Context) ([]int, error) {
	if len(wis.fields) > 1 {
		return nil, errors.New("ent: WorkflowInstanceSelect.Ints is not achievable when selecting more than 1 field")
	}
	var v []int
	if err := wis.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (wis *WorkflowInstanceSelect) IntsX(ctx context.Context) []int {
	v, err := wis.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a selector. It is only allowed when selecting one field.
func (wis *WorkflowInstanceSelect) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = wis.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workflowinstance.Label}
	default:
		err = fmt.Errorf("ent: WorkflowInstanceSelect.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (wis *WorkflowInstanceSelect) IntX(ctx context.Context) int {
	v, err := wis.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from a selector. It is only allowed when selecting one field.
func (wis *WorkflowInstanceSelect) Float64s(ctx context.Context) ([]float64, error) {
	if len(wis.fields) > 1 {
		return nil, errors.New("ent: WorkflowInstanceSelect.Float64s is not achievable when selecting more than 1 field")
	}
	var v []float64
	if err := wis.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (wis *WorkflowInstanceSelect) Float64sX(ctx context.Context) []float64 {
	v, err := wis.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a selector. It is only allowed when selecting one field.
func (wis *WorkflowInstanceSelect) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = wis.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workflowinstance.Label}
	default:
		err = fmt.Errorf("ent: WorkflowInstanceSelect.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (wis *WorkflowInstanceSelect) Float64X(ctx context.Context) float64 {
	v, err := wis.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from a selector. It is only allowed when selecting one field.
func (wis *WorkflowInstanceSelect) Bools(ctx context.Context) ([]bool, error) {
	if len(wis.fields) > 1 {
		return nil, errors.New("ent: WorkflowInstanceSelect.Bools is not achievable when selecting more than 1 field")
	}
	var v []bool
	if err := wis.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (wis *WorkflowInstanceSelect) BoolsX(ctx context.Context) []bool {
	v, err := wis.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a selector. It is only allowed when selecting one field.
func (wis *WorkflowInstanceSelect) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = wis.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workflowinstance.Label}
	default:
		err = fmt.Errorf("ent: WorkflowInstanceSelect.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (wis *WorkflowInstanceSelect) BoolX(ctx context.Context) bool {
	v, err := wis.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (wis *WorkflowInstanceSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := wis.sqlQuery().Query()
	if err := wis.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (wis *WorkflowInstanceSelect) sqlQuery() sql.Querier {
	selector := wis.sql
	selector.Select(selector.Columns(wis.fields...)...)
	return selector
}
